unit nlcl1;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, Math, Libc, QTypes, QMenus, nlcl2;

type
  TForm1 = class(TForm)
    Shape1: TShape;
    Shape2: TShape;
    Button2: TButton;
    PaintBox1: TPaintBox;
    DirBox: TListBox;
    FileBox: TListBox;
    Image1: TImage;
    LSize: TComboBox;
    LType: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button3: TButton;
    Timer1: TTimer;
    Shape3: TShape;
    Shape4: TShape;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Shape5: TShape;
    Button8: TButton;
    UpPos: TEdit;
    Label3: TLabel;
    Button9: TButton;
    Label4: TLabel;
    DownPos: TEdit;
    Status: TMemo;
    PopupMenu1: TPopupMenu;
    ConverttoNokiaLogo1: TMenuItem;
    ConverttoBitmap1: TMenuItem;
    Copy1: TMenuItem;
    Rename1: TMenuItem;
    Delete1: TMenuItem;
    UploadtoMobile1: TMenuItem;
    GetfromMobile1: TMenuItem;
    About1: TMenuItem;
    PopupMenu2: TPopupMenu;
    CreateDirectory1: TMenuItem;
    DeleteDirectoryRecursively1: TMenuItem;
    GotoRoot1: TMenuItem;
    GotoHome1: TMenuItem;
    Selector: TComboBox;
    RenameDirectory1: TMenuItem;
    Button10: TButton;
    FontDialog1: TFontDialog;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DirBoxDblClick(Sender: TObject);
    procedure FileBoxClick(Sender: TObject);
    procedure ReadNL;
    procedure FileBoxKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CreateDirectory1Click(Sender: TObject);
    procedure DeleteDirectoryRecursively1Click(Sender: TObject);
    procedure GotoHome1Click(Sender: TObject);
    procedure GotoRoot1Click(Sender: TObject);
    procedure SelectorClick(Sender: TObject);
    procedure RenameDirectory1Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  FileName: string;
  CWD: string;
  Created: boolean;
  i, ending: integer;
  func, valu: string;
  Counter: integer;

implementation

{$R *.xfm}
function RunCommand(Command: widestring):widestring;
var
 cmd: PChar;
 file1: PIOFile;
 a: array [0..500000] of Char;
 i,c: integer;
 s: string;
 label finish;
begin
  i:=0;
  c:=0;
  cmd:=StrAlloc(600);
  StrPCopy(cmd,Command);
  file1:=popen(cmd, 'r');
  for i:=0 to 499999 do begin
   c:=fgetc(file1);
   if (c=0) or (c=-1) or (c<1) or (c>255) then goto finish;
   a[i]:=Char(c);
  end;
  finish:
  s:='';
  for c:=0 to i do
     s:=s+a[c];
  result:=s;
  pclose(file1);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
s,s2,sub,part1, part2, newCWD: string;
P: PChar;
l,f,m,n: integer;
g: TextFile;
FontDialog1FontName: string;
FontDialog1FontSize: integer;
begin
 LType.ItemIndex:=0;
 LSize.ItemIndex:=0;
 Image1.Picture.Bitmap:=TBitmap.Create;
 Image1.Canvas.Refresh;
 Image1.Picture.Bitmap.Height:=Image1.Height;
 Image1.Picture.Bitmap.Width:=Image1.Width;
 CWD:=GetCurrentDir;
 Selector.Text:=CWD;
 m:=0;
 NewCWD:=CWD;
 Selector.Items.Clear;
 repeat
  if NewCWD='/' then m:=1;
  Selector.Items.Add(NewCWD);
  ChDir('..');
  NewCWD:=GetCurrentDir;
 until (NewCWD='/') and (m=1);
 ChDir(CWD);
 created:=false;
 s:=RunCommand('ls -1 -p');
 l:=1;
 P:=StrAlloc(length(s)+1);
 StrPCopy(P,s);
 DirBox.Items.Add('../');
 f:=-1;
 repeat
   inc(f);
   if (Integer(P[f])=10) and (f<>length(s)-1) then begin
    if (Pos('/',s2)=0) and (Pos('@',s2)=0) then begin
     FileBox.Items.Add(s2);
    end else begin
     if Pos('/',s2)<>0 then begin
      Delete(s2,Length(s2),Length(s2));
      DirBox.Items.Add(s2);
     end else if Pos('@',s2)<>0 then begin
      Delete(s2,Length(s2),Length(s2));
      if DirectoryExists(s2) then
       DirBox.Items.Add(s2)
      else
       FileBox.Items.Add(s2);
     end;
    end;
    s2:='';
    inc(l);
    inc(f);
   end;
   s2:=s2 + P[f];
  until f=length(s);
  P:=nil;
  i:=0;

  if FileExists( '.nlcl-fonts') then begin
  AssignFile(g, '.nlcl-fonts');
  Reset(g);
  ReadLn(g, FontDialog1FontName);
  ReadLn(g, s);
  FontDialog1FontSize:=StrToInt(s);
  CloseFile(g);
  Selector.Font.Name:=FontDialog1FontName;
  Selector.Font.Size:=FontDialog1FontSize;
  DirBox.Font.Name:=FontDialog1FontName;
  DirBox.Font.Size:=FontDialog1FontSize;
  FileBox.Font.Name:=FontDialog1FontName;
  FileBox.Font.Size:=FontDialog1FontSize;
  Label1.Font.Name:=FontDialog1FontName;
  Label1.Font.Size:=FontDialog1FontSize+1;
  Label2.Font.Name:=FontDialog1FontName;
  Label2.Font.Size:=FontDialog1FontSize+1;
  LSize.Font.Name:=FontDialog1FontName;
  LSize.Font.Size:=FontDialog1FontSize+1;
  LType.Font.Name:=FontDialog1FontName;
  LType.Font.Size:=FontDialog1FontSize+1;
  Button1.Font.Name:=FontDialog1FontName;
  Button1.Font.Size:=FontDialog1FontSize;
  Button2.Font.Name:=FontDialog1FontName;
  Button2.Font.Size:=FontDialog1FontSize;
  Button3.Font.Name:=FontDialog1FontName;
  Button3.Font.Size:=FontDialog1FontSize;
  Button4.Font.Name:=FontDialog1FontName;
  Button4.Font.Size:=FontDialog1FontSize;
  Button5.Font.Name:=FontDialog1FontName;
  Button5.Font.Size:=FontDialog1FontSize;
  Button6.Font.Name:=FontDialog1FontName;
  Button6.Font.Size:=FontDialog1FontSize;
  Button7.Font.Name:=FontDialog1FontName;
  Button7.Font.Size:=FontDialog1FontSize;
  Button8.Font.Name:=FontDialog1FontName;
  Button8.Font.Size:=FontDialog1FontSize;
  Button9.Font.Name:=FontDialog1FontName;
  Button9.Font.Size:=FontDialog1FontSize;
  Button10.Font.Name:=FontDialog1FontName;
  Button10.Font.Size:=FontDialog1FontSize;
  Status.Font.Name:=FontDialog1FontName;
  Status.Font.Size:=FontDialog1FontSize;
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
 f: file of Byte;
 n:Byte;
 Hex,value: Word;
 x,y,g,j,k: integer;
 Byte:string[8];
 bcount:integer;
 Bin:Array[0..7] of Char;
 PBin:PChar;
 sett:boolean;
 filename,typ:string;
begin
if FileBox.SelCount=1 then begin
 i:=0;
 filename:=FileBox.Items[FileBox.ItemIndex];
 if LType.ItemIndex=0 then begin
  filename:=ChangeFileExt(filename,'.nlm');
  typ:='nlm';
 end else if LType.ItemIndex=1 then begin
  filename:=ChangeFileExt(filename,'.nol');
  typ:='nol';
 end else if LType.ItemIndex=2 then begin
  filename:=ChangeFileExt(filename,'.ngg');
  typ:='ngg';
 end;
 AssignFile(f,CWD+'/'+filename);
 Rewrite(f);
 sett:=false;
if typ='nlm' then begin
 n:=$4e;
 Write(f,n);
 n:=$4c;
 Write(f,n);
 n:=$4d;
 Write(f,n);
 n:=$20;
 Write(f,n);
 n:=$01;
 Write(f,n);
 n:=$03;
 Write(f,n);
 n:=$00;
 Write(f,n);
 n:=$48;
 Write(f,n);
end else if typ='nol' then begin
 n:=$4e;
 Write(f,n);
 n:=$4f;
 Write(f,n);
 n:=$4c;
 Write(f,n);
 n:=$00;
 Write(f,n);
 n:=$01;
 Write(f,n);
 n:=$00;
 for g:=1 to 5 do
  Write(f,n);
 n:=$48;
 Write(f,n);
 n:=$00;
 Write(f,n);
end;
 if LSize.ItemIndex=0 then
  n:=28 else n:=14;
 Write(f,n);
if typ='nlm' then begin
 n:=$01;
 Write(f,n);
 y:=0;
 x:=0;
 bcount:=0;
 Byte:='';
 repeat
  if x=72 then begin
   inc(y);
   x:=0;
  end;
  PBin:=Bin;
  inc(bcount);
  PaintBox1.Canvas.Refresh;
  PaintBox1.Canvas.Draw(0,0,Image1.Picture.Bitmap);
  if PaintBox1.Canvas.Pixels[x,y]=clBlack then
   Byte:=Byte+'1'
  else
   Byte:=Byte+'0';
  if bcount=8 then begin
   bcount:=0;
   Hex:=0;
   StrPCopy(PBin,Byte);
   Byte:='';
   for g:=0 to 7 do begin
    value:=Round(Power(2,g));
    if PBin[7-g]='1' then
     Hex:=Hex+value;
   end;
   Write(f,Hex);
  end;
  inc(x);
 until y=Image1.Height+1;
end else if typ='nol' then begin
 n:=$00;
 Write(f,n);
 n:=$01;
 Write(f,n);
 n:=$00;
 Write(f,n);
 n:=$01;
 Write(f,n);
 n:=$00;
 Write(f,n);
 n:=$3b;
 Write(f,n);
 n:=$00;
 Write(f,n);
 y:=0;
 x:=0;
 bcount:=0;
 Byte:='';
 repeat
  if x=72 then begin
   inc(y);
   x:=0;
  end;
  PaintBox1.Canvas.Refresh;
  PaintBox1.Canvas.Draw(0,0,Image1.Picture.Bitmap);
  if PaintBox1.Canvas.Pixels[x,y]=clBlack then begin
   n:=49;
   Write(f,n);
  end else begin
   n:=48;
   Write(f,n);
  end;
  inc(x);
 until y=Image1.Height+1;
end;
 CloseFile(f);
 FileBox.Items.Clear;
 DirBox.Items.Clear;
 FormCreate(sender);
 Status.Lines.Add('Converted Bitmap to '+filename+' successfully.');
end else if FileBox.SelCount>1 then begin
 i:=0;
 k:=0;
 func:='cnvtonok';
 while FileBox.Selected[k]=false do
   inc(k);
 i:=k;
 for k:=i to FileBox.Items.Count-1 do begin
  if FileBox.Selected[k] then
   ending:=k;
 end;
 Status.Lines.Add('--> Started converting Files...');
 Timer1.Enabled:=True;
end; 
end;

procedure TForm1.DirBoxDblClick(Sender: TObject);
var
s,s2, NewCWD: string;
P: PChar;
l,i,m: integer;
begin
 if DirBox.Items[DirBox.ItemIndex]='../' then begin
  s:=RunCommand('cd '''+CWD+''' && cd .. && ls -1 -p');
  ChDir('..');
  CWD:=GetCurrentDir;
 end else begin
  s:=RunCommand('cd '''+CWD+''' && cd '''+DirBox.Items[DirBox.ItemIndex]+''' && ls -1 -p');
  ChDir(DirBox.Items[DirBox.ItemIndex]);
  CWD:=GetCurrentDir;
 end;
  DirBox.Items.Clear;
  FileBox.Items.Clear;
  Selector.Text:=CWD;
  m:=0;
  NewCWD:=CWD;
  Selector.Items.Clear;
  repeat
   if NewCWD='/' then m:=1;
   Selector.Items.Add(NewCWD);
   ChDir('..');
   NewCWD:=GetCurrentDir;
  until (NewCWD='/') and (m=1);
  ChDir(CWD); 
  DirBox.Items.Add('../');
  l:=1;
  P:=StrAlloc(length(s)+1);
  StrPCopy(P,s);
  i:=-1;
  repeat
   inc(i);
   if (Integer(P[i])=10) and (i<>length(s)-1) then begin
    if (Pos('/',s2)=0) and (Pos('@',s2)=0) then begin
     FileBox.Items.Add(s2);
    end else begin
     if Pos('/',s2)<>0 then begin
      Delete(s2,Length(s2),Length(s2));
      DirBox.Items.Add(s2);
     end else if Pos('@',s2)<>0 then begin
      Delete(s2,Length(s2),Length(s2));
      if DirectoryExists(s2) then
       DirBox.Items.Add(s2)
      else
       FileBox.Items.Add(s2);
     end;
    end;
    s2:='';
    inc(l);
    inc(i);
   end;
   s2:=s2 + P[i];
  until i=length(s);
  P:=nil;
end;

function IntToBin(n: byte):string;
var
 i: integer;
 x: extended;
 P: PChar;
 Pin: array[0..8] of Char;
begin
 P:=Pin;
 if n=255 then begin
  P:='11111111';
 end else begin
  for i:=7 downto 0 do begin
   x:=n / Power(2,i);
   if x>=1 then begin
    P[7-i]:='1';
    n:=n-Round(Power(2,i));
   end else begin
    P[7-i]:='0';
   end;
  end;
  P[8]:=#0;
 end;
 result:=StrPas(P);
 P:=nil;
end;

procedure TForm1.ReadNL;
var
 f: file of Byte;
 n:Byte;
 height: integer;
 binvalue: pchar;
 x,y,g,j,z: integer;
 Bin:Array[0..8] of Char;
 filename:string;
 r: TRect;
 typ: string;
 oldfilemode: byte;
 label finish;
begin
  Image1.Canvas.Pen.Color:=clWhite;
  Image1.Canvas.Pen.Width:=Image1.Height;
  Image1.Canvas.MoveTo(0,Image1.Height div 2);
  Image1.Canvas.LineTo(Image1.Width,Image1.Height div 2);
  if i=0 then begin
   AssignFile(f,CWD+'/'+FileBox.Items[FileBox.ItemIndex]);
  end else begin
   AssignFile(f,CWD+'/'+FileBox.Items[i]);
  end;
  oldfilemode:=Filemode;
  FileMode:=fmOpenRead;
  Reset(f);
  FileMode:=oldFilemode;
  g:=0;
  x:=0;
  y:=0;
  BinValue:=Bin;
  Read(f,n);
  if n=78 then typ:='n';
  Read(f,n);
  if n=76 then typ:='nl';
  if n=79 then typ:='no';
  Read(f,n);
  if n=77 then typ:='nlm';
  if n=76 then typ:='nol';
  Read(f,n);
  if n<>32 then typ:='nol';
  Read(f,n);
  Read(f,n);
  Read(f,n);
  Read(f,n);
  if (typ='nlm') and (n<>72) then goto finish;
  Read(f,n);
  if (typ='nlm') then begin
   if(n=28) then height:=28 else height:=14;
   Shape2.Height:=height+4;
   Image1.Height:=height;
   Image1.Picture.Bitmap.Height:=height;
   Read(f,n);
   if n<>1 then goto finish;
  end else if (typ='nol') then begin
    Read(f,n);
    Read(f,n);
    if n<>72 then goto finish;
    Read(f,n);
    Read(f,n);
    if(n=28) then height:=28 else height:=14;
    Shape2.Height:=height+4;
    Image1.Height:=height;
    Image1.Picture.Bitmap.Height:=height;
    Read(f,n);
    Read(f,n);
    Read(f,n);
    Read(f,n);
    Read(f,n);
    Read(f,n);
    Read(f,n);
  end;
  Image1.Canvas.Pen.Color:=clWhite;
  Image1.Canvas.Pen.Width:=Image1.Height;
  Image1.Canvas.MoveTo(0,Image1.Height div 2);
  Image1.Canvas.LineTo(Image1.Width,Image1.Height div 2);
if typ='nlm' then begin
  while not eof(f) do begin
   inc(g);
   if x=72 then begin
    inc(y);
    x:=0;
   end;
   Read(f,n);
   StrPcopy(Binvalue,IntToBin(n));
   for z:=0 to 7 do
    if Binvalue[z]='1' then Image1.Canvas.Pixels[x+z,y]:=clBlack;
   inc(x,8);
  end;
 end else if typ='nol' then begin
  while not eof(f) do begin
   inc(g);
   if x=72 then begin
    inc(y);
    x:=0;
   end;
   Read(f,n);
   if Chr(n)='1' then Image1.Canvas.Pixels[x,y]:=clBlack;
   inc(x);
  end;
 end; 
  finish:
  CloseFile(f);
  BinValue:=nil;
end;

procedure TForm1.FileBoxClick(Sender: TObject);
var
fileext: string;
begin
 try
  fileext:=LowerCase(FileBox.Items[FileBox.ItemIndex]);
 except on EStringListError do
 end;
 Delete(Fileext,1,Length(Fileext)-3);
 if (fileext='bmp') or
    (fileext='jpg') or
    (fileext='xpm') or
    (fileext='png') or
    (fileext='wmf') or
    (fileext='xmf') then begin
  Image1.Picture.LoadFromFile(CWD+'/'+FileBox.Items[FileBox.ItemIndex]);
  Image1.Canvas.Refresh;
  if not (Image1.Picture.Bitmap.Height > 28) then
   Image1.Height:=Image1.Picture.Bitmap.Height
  else
   Image1.Height:=28;
  if Image1.Height=28 then LSize.ItemIndex:=0 else LSize.ItemIndex:=1;
  Shape2.Height:=Image1.height+4;
 end else
 if (fileext='nlm') or
    (fileext='nol') {or
    (fileext='ngg') } then begin
  ReadNL;
  if Pos('.nlm',LowerCase(FileBox.Items[FileBox.ItemIndex]))<>0 then
   LType.ItemIndex:=0;
  if Pos('.nol',LowerCase(FileBox.Items[FileBox.ItemIndex]))<>0 then
   LType.ItemIndex:=1;
  if Pos('.ngg',LowerCase(FileBox.Items[FileBox.ItemIndex]))<>0 then
   LType.ItemIndex:=2;
  if Image1.Height=28 then LSize.ItemIndex:=0 else LSize.ItemIndex:=1;
 end;
end;

procedure TForm1.FileBoxKeyPress(Sender: TObject; var Key: Char);
begin
 FileBoxClick(sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
filename: string;
f,g:LongInt;
begin
if FileBox.SelCount=1 then begin
 i:=0;
 if (Pos('.nlm',LowerCase(FileBox.Items[FileBox.ItemIndex]))<>0) or
    (Pos('.nol',LowerCase(FileBox.Items[FileBox.ItemIndex]))<>0) or
    (Pos('.ngg',LowerCase(FileBox.Items[FileBox.ItemIndex]))<>0)
  then begin
   filename:=FileBox.Items[FileBox.ItemIndex];
   filename:=ChangeFileExt(filename,'.bmp');
   Image1.Picture.SaveToFile(CWD+'/'+filename);
  end;
  FileBox.Items.Clear;
  DirBox.Items.Clear;
  FormCreate(sender);
  Status.Lines.Add('Converted Nokia logo file to '+filename+' successfully.');
end else if FileBox.SelCount>1 then begin
 i:=0;
 f:=0;
 while FileBox.Selected[f]=false do
   inc(f);
 i:=f;
 for f:=i to FileBox.Items.Count-1 do begin
  if FileBox.Selected[f] then
   ending:=f;
 end;
 func:='cnvtobit';
 Status.Lines.Add('--> Started converting Files...');
 Timer1.Enabled:=True;
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 MessageDlg('Copyright-notice',' NLCL 0.9.8 Copyright (C) 2002 Elias Jahn <elias_jahn@clix.pt> This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License'+
 'as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.'+
'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty'+
'of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.'+
'You should have received a copy of the GNU General Public License along with this program (see the file COPYING); if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA'+
'                                                                                                   '+
'Here is a small help: File- and DirBox Navigation: Double click to enter directory, right mouse button for context menu, press and hold CTRL for Multiselect (or use CTRL and then SHIFT)', mtInformation,[mbOk],0);
end;

function RenameByRule1(filename, existing, newtext: string): string;
var
 old, new, part1, part2: string;
 exPos, len: integer;
begin
 old:=filename;
 new:=filename;
 exPos:=Pos(existing, old);
 len:=Length(existing);
 Delete(New,exPos,len);
 part1:=new;
 part2:=new;
 Delete(part1,exPos,Length(part1)-exPos+1);
 Delete(part2,1,expos-1);
 new:=part1+newtext+part2;
 Result:=new;
end;

function RenameByRule2(filename, text: string; beginning, ending: boolean): string;
var
 new: string;
begin
 New:=filename;
 if beginning then New:=text+New;
 if ending then New:=new+text;
 Result:=new;
end;

function RenameByRule3(filename: string; chars: integer; beginning, ending: boolean): string;
var
 new: string;
begin
 new:=filename;
 if beginning then Delete(New, 1, chars);
 if ending then Delete(New, Length(New)-chars+1, chars);
 Result:=new;
end;

function RenameByRule4(common: string; numstart: integer): string;
begin
 Result:=Common+IntToStr(Counter);
 Inc(Counter);
end;

function RenameByRule56(filename, upperlower: string): string;
begin
 if (upperlower='upper') then result:=UpperCase(filename);
 if (upperlower='lower') then result:=lowercase(filename);
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
 f: file of Byte;
 n:Byte;
 Hex,value: Word;
 x,y,g,j,k: integer;
 Byte:string[8];
 bcount:integer;
 Bin:Array[0..7] of Char;
 PBin:PChar;
 sett:boolean;
 filename,typ, s, newname, extention:string;
begin
 if FileBox.Selected[i]=true then begin
  if func='delete' then begin
   filename:=FileBox.Items[i];
   s:=RunCommand('rm --force '''+CWD+'/'+filename+'''');
   Status.Lines.Add('Deleted File '+filename+' , eventual error messages follow: ');
   Status.Lines.Add(s);
  end else
  if func='rename' then begin
   filename:=FileBox.Items[i];
   if RenameWin.RenameIndividual.Checked then begin
    Timer1.Enabled:=false;
    newname:=filename;
    if (InputQuery('Rename File: '+filename, 'Insert the new name: ', newname)=true) then begin
     if newname<>'' then begin
      if Pos(ExtractFileExt(filename),newname)=0 then
       newname:=newname+ExtractFileExt(filename);
      s:=RunCommand('cd '''+CWD+''' && mv '''+filename+''' '''+newname+'''');
      Status.Lines.Add('Renamed File '+filename+' to '+newname+' , eventual error messages follow: ');
      Status.Lines.Add(s);
     end else begin
      Status.Lines.Add('<!> Error!! You must insert a name.');
     end;
    end; 
    Timer1.Enabled:=True;
   end else
   if RenameWin.RenameRules.checked then begin
    Timer1.Enabled:=false;
    extention:=ExtractFileExt(filename);
    Delete(filename, Pos(Extention, filename), 4);
    newname:=filename;
    if RenameWin.Rule1.checked then begin
     newname:=RenameByRule1(newname, RenameWin.Rule1Find.Text, RenameWin.Rule1Subst.Text);
    end;
    if RenameWin.Rule2.checked then begin
     newname:=RenameByRule2(newname,RenameWin.AddText.Text, RenameWin.Rule2Begin.Checked, RenameWin.Rule2End.checked);
    end;
    if RenameWin.Rule3.checked then begin
     newname:=RenameByRule3(newname, StrToInt(RenameWin.RemoveN.Text),RenameWin.Rule3Begin.checked, RenameWin.Rule3End.Checked);
    end;
    if RenameWin.Rule4.checked then begin
     newname:=RenameByRule4(RenameWin.Rule4Common.Text, StrToInt(RenameWin.Rule4Start.Text));
    end;
    if RenameWin.Rule5.checked then begin
      newname:=RenameByRule56(newname, 'upper');
    end;
    if RenameWin.Rule6.checked then begin
      newname:=RenameByRule56(newname, 'lower');
    end;
    if newname<>'' then begin
     filename:=filename+extention;
     newname:=newname+extention;
     s:=RunCommand('cd '''+CWD+''' && mv '''+filename+''' '''+newname+'''');
     Status.Lines.Add('Renamed File '+filename+' to '+newname+' , eventual error messages follow: ');
     Status.Lines.Add(s);
    end else begin
     Status.Lines.Add('<!> Error!! You didn''t specify needed parameters or something else went wrong.');
    end;
    Timer1.Enabled:=True;
   end;
  end else
  if func='copy' then begin
   s:=RunCommand('cp '''+CWD+'/'+FileBox.Items[i]+''' '''+valu+'''');
   Status.Lines.Add('Finished Copying File '+FileBox.Items[i]+' , eventual error messages follow: ');
   Status.Lines.Add(s);
  end else
  if func='cnvtobit' then begin
    if (Pos('.nlm',LowerCase(FileBox.Items[i]))<>0) or
     (Pos('.nol',LowerCase(FileBox.Items[i]))<>0) or
     (Pos('.ngg',LowerCase(FileBox.Items[i]))<>0)
    then begin
     ReadNL;
     if Pos('.nlm',LowerCase(FileBox.Items[i]))<>0 then
      LType.ItemIndex:=0;
     if Pos('.nol',LowerCase(FileBox.Items[i]))<>0 then
      LType.ItemIndex:=1;
     if Pos('.ngg',LowerCase(FileBox.Items[i]))<>0 then
      LType.ItemIndex:=2;
     if Image1.Height=28 then LSize.ItemIndex:=0 else LSize.ItemIndex:=1;
     filename:=FileBox.Items[i];
     filename:=ChangeFileExt(filename,'.bmp');
     Image1.Picture.SaveToFile(CWD+'/'+filename);
    end;
    Status.Lines.Add('Converted Nokia logo file to '+filename+' successfully.');
  end else
  if func='cnvtonok' then begin
   if (Pos('.nlm',LowerCase(FileBox.Items[i]))=0) and
     (Pos('.nol',LowerCase(FileBox.Items[i]))=0) and
     (Pos('.ngg',LowerCase(FileBox.Items[i]))=0)
   then begin
    filename:=FileBox.Items[i];
    if LType.ItemIndex=0 then begin
     filename:=ChangeFileExt(filename,'.nlm');
     typ:='nlm';
    end else if LType.ItemIndex=1 then begin
     filename:=ChangeFileExt(filename,'.nol');
     typ:='nol';
    end else if LType.ItemIndex=2 then begin
     filename:=ChangeFileExt(filename,'.ngg');
     typ:='ngg';
    end;
    AssignFile(f,CWD+'/'+filename);
    Rewrite(f);
    sett:=false;
    if typ='nlm' then begin
     n:=$4e;
     Write(f,n);
     n:=$4c;
     Write(f,n);
     n:=$4d;
     Write(f,n);
     n:=$20;
     Write(f,n);
     n:=$01;
     Write(f,n);
     n:=$03;
     Write(f,n);
     n:=$00;
     Write(f,n);
     n:=$48;
     Write(f,n);
    end else if typ='nol' then begin
     n:=$4e;
     Write(f,n);
     n:=$4f;
     Write(f,n);
     n:=$4c;
     Write(f,n);
     n:=$00;
     Write(f,n);
     n:=$01;
     Write(f,n);
     n:=$00;
     for g:=1 to 5 do
      Write(f,n);
     n:=$48;
     Write(f,n);
     n:=$00;
     Write(f,n);
    end;
    if LSize.ItemIndex=0 then
     n:=28 else n:=14;
    Write(f,n);
    if typ='nlm' then begin
     n:=$01;
     Write(f,n);
     y:=0;
     x:=0;
     bcount:=0;
     Byte:='';
     repeat
      if x=72 then begin
       inc(y);
       x:=0;
      end;
      PBin:=Bin;
      inc(bcount);
      Image1.Picture.LoadFromFile(CWD+'/'+FileBox.Items[i]);
      Image1.Canvas.Refresh;
      Image1.Height:=Image1.Picture.Bitmap.Height;
      if Image1.Height=28 then LSize.ItemIndex:=0 else LSize.ItemIndex:=1;
      Shape2.Height:=Image1.height+4;
      PaintBox1.Canvas.Refresh;
      PaintBox1.Canvas.Draw(0,0,Image1.Picture.Bitmap);
      if PaintBox1.Canvas.Pixels[x,y]=clBlack then
       Byte:=Byte+'1'
      else
       Byte:=Byte+'0';
      if bcount=8 then begin
       bcount:=0;
       Hex:=0;
       StrPCopy(PBin,Byte);
       Byte:='';
       for g:=0 to 7 do begin
        value:=Round(Power(2,g));
        if PBin[7-g]='1' then
         Hex:=Hex+value;
       end;
       Write(f,Hex);
      end;
      inc(x);
     until y=Image1.Height+1;
    end else if typ='nol' then begin
     n:=$00;
     Write(f,n);
     n:=$01;
     Write(f,n);
     n:=$00;
     Write(f,n);
     n:=$01;
     Write(f,n);
     n:=$00;
     Write(f,n);
     n:=$3b;
     Write(f,n);
     n:=$00;
     Write(f,n);
     y:=0;
     x:=0;
     bcount:=0;
     Byte:='';
     repeat
      if x=72 then begin
       inc(y);
       x:=0;
      end;
      Image1.Picture.LoadFromFile(CWD+'/'+FileBox.Items[i]);
      Image1.Canvas.Refresh;
      Image1.Height:=Image1.Picture.Bitmap.Height;
      if Image1.Height=28 then LSize.ItemIndex:=0 else LSize.ItemIndex:=1;
      Shape2.Height:=Image1.height+4;
      PaintBox1.Canvas.Refresh;
      PaintBox1.Canvas.Draw(0,0,Image1.Picture.Bitmap);
      if PaintBox1.Canvas.Pixels[x,y]=clBlack then begin
       n:=49;
       Write(f,n);
      end else begin
       n:=48;
       Write(f,n);
      end;
      inc(x);
     until y=Image1.Height+1;
    end;
   end;
   Status.Lines.Add('Converted Bitmap to '+filename+' successfully.');
  end;
 end;
 inc(i);
 if i=ending+1 then begin
  Timer1.Enabled:=false;
  Status.Lines.Add('Finished.');
  FileBox.Items.Clear;
  DirBox.Items.Clear;
  FormCreate(sender);
 end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
f: longint;
dir,s: string;
begin
if FileBox.SelCount=1 then begin
 i:=0;
 filename:=FileBox.Items[FileBox.ItemIndex];
 dir:=InputBox('Destination Directory', 'Insert Directory where to copy to the files: ', CWD);
 if dir<>CWD then begin
  s:=RunCommand('cp '''+CWD+'/'+filename+''' '''+dir+'''');
  Status.Lines.Add('Finished Copying File '+filename+' , eventual error messages follow: ');
  Status.Lines.Add(s);
  FileBox.Items.Clear;
  DirBox.Items.Clear;
  FormCreate(sender);
 end;
end else if FileBox.SelCount>1 then begin
 i:=0;
 f:=0;
 while FileBox.Selected[f]=false do
   inc(f);
 i:=f;
 for f:=i to FileBox.Items.Count-1 do begin
  if FileBox.Selected[f] then
   ending:=f;
 end;
 func:='copy';
 valu:=InputBox('Destination Directory', 'Insert Directory where to copy to the files: ', CWD);
 if valu<>CWD then begin
  Status.Lines.Add('--> Started copying Files...');
  Timer1.Enabled:=True;
 end; 
end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
f: longint;
newname,s: string;
begin
if FileBox.SelCount=1 then begin
 i:=0;
 filename:=FileBox.Items[FileBox.ItemIndex];
 newname:=filename;
 if (InputQuery('Rename File: '+filename, 'Insert new name for the file: ', newname)=true) then begin
  if newname<>'' then begin
   if Pos(ExtractFileExt(filename),newname)=0 then
    newname:=newname+ExtractFileExt(filename);
   s:=RunCommand('cd '''+CWD+''' && mv '''+filename+''' '''+newname+'''');
   Status.Lines.Add('Finished Renaming File '+filename+' to '+newname+' , eventual error messages follow: ');
   Status.Lines.Add(s);
   FileBox.Items.Clear;
   DirBox.Items.Clear;
   FormCreate(sender);
  end else begin
   Status.Lines.Add('<!> Error!! You must insert a name.');
  end;
 end;
end else if FileBox.SelCount>1 then begin
 i:=0;
 f:=0;
 while FileBox.Selected[f]=false do
   inc(f);
 i:=f;
 for f:=i to FileBox.Items.Count-1 do begin
  if FileBox.Selected[f] then
   ending:=f;
 end;

 func:='rename';
 RenameWin.Caption:='Rename-Options';
  RenameWin.Show;
end;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
f, count: longint;
s: string;
begin
if FileBox.SelCount=1 then begin
 i:=0;
 filename:=FileBox.Items[FileBox.ItemIndex];
 if MessageDlg('Delete File','Really Delete File: '+filename+' ?!',mtWarning,[mbYes,mbNo],0)=mrYes then begin
  s:=RunCommand('rm --force '''+CWD+'/'+filename+'''');
  Status.Lines.Add('Finished Deleting File '+filename+' , eventual error messages follow: ');
  Status.Lines.Add(s);
  FileBox.Items.Clear;
  DirBox.Items.Clear;
  FormCreate(sender);
 end else begin
  Status.Lines.Add('Cancelled.');
 end;
end else if FileBox.SelCount>1 then begin
 i:=0;
 f:=0;
 while FileBox.Selected[f]=false do
   inc(f);
 i:=f;
 count:=0;
 for f:=i to FileBox.Items.Count-1 do begin
  if FileBox.Selected[f] then begin
   ending:=f;
   inc(count);
  end;
 end;
 func:='delete';
 if MessageDlg('Delete File','Really Delete '+IntToStr(count)+' Files ?!',mtWarning,[mbYes,mbNo],0)=mrYes then begin
  Status.Lines.Add('--> Started deleting Files...');
  Timer1.Enabled:=True;
 end else begin
  Status.Lines.Add('Cancelled.');
 end;
end;
end;

procedure TForm1.CreateDirectory1Click(Sender: TObject);
var
 s,dir: string;
begin
 dir:=InputBox('Create a Directory','Name of new directory: ','');
 s:=RunCommand('cd '''+CWD+''' && mkdir '''+dir+'''');
 Status.Lines.Add('Created new directory '+dir);
 FileBox.Items.Clear;
 DirBox.Items.Clear;
 FormCreate(sender);
end;

procedure TForm1.DeleteDirectoryRecursively1Click(Sender: TObject);
var
 s: string;
begin
 if MessageDlg('Delete Directory recursively','Danger! Are you sure you really want to delete the directory '+DirBox.Items[DirBox.ItemIndex]+' and all its content ??!',mtWarning,[mbYes,mbNo],0)=mrYes then begin
  Status.Lines.Add('Deleting Directory '+DirBox.Items[DirBox.ItemIndex]+' recursively...');
  s:=RunCommand('cd '''+CWD+''' && rm --force -r '''+DirBox.Items[DirBox.ItemIndex]+'''');
  FileBox.Items.Clear;
  DirBox.Items.Clear;
  FormCreate(sender);
  Status.Lines.Add('Done.');
end else begin
 Status.Lines.Add('Cancelled.');
end;  
end;

procedure TForm1.GotoHome1Click(Sender: TObject);
var
 s, dir: string;
begin
 dir:=RunCommand('cd $home && echo $PWD');
 Delete(dir,Length(dir)-1,2);
 ChDir(dir);
 FileBox.Items.Clear;
 DirBox.Items.Clear;
 FormCreate(sender);  
end;

procedure TForm1.GotoRoot1Click(Sender: TObject);
begin
 ChDir('/');
 FileBox.Items.Clear;
 DirBox.Items.Clear;
 FormCreate(sender);
end;

procedure TForm1.SelectorClick(Sender: TObject);
begin
 ChDir(Selector.Text);
 FileBox.Items.Clear;
 DirBox.Items.Clear;
 FormCreate(sender);
end;

procedure TForm1.RenameDirectory1Click(Sender: TObject);
var
 s,dir,old: string;
begin
 old:=DirBox.Items[DirBox.ItemIndex];
 dir:=old;
 if InputQuery('Rename Directory: '+dir, 'Enter new name: ', dir) = true then begin
  s:=RunCommand('cd '''+CWD+''' && mv '''+old+''' '''+dir+'''');
  Status.Lines.Add('Renamed directory '+old+' to '+dir);
  FileBox.Items.Clear;
  DirBox.Items.Clear;
  FormCreate(sender);
 end;
end;

procedure TForm1.Button10Click(Sender: TObject);
var
f: TextFile;
begin
 ShowMessage('With the following dialog you can change the default font used for the controls in NLCL.');
 if FontDialog1.Execute then begin
  Selector.Font.Name:=FontDialog1.Font.Name;
  Selector.Font.Size:=FontDialog1.Font.Size;
  DirBox.Font.Name:=FontDialog1.Font.Name;
  DirBox.Font.Size:=FontDialog1.Font.Size;
  FileBox.Font.Name:=FontDialog1.Font.Name;
  FileBox.Font.Size:=FontDialog1.Font.Size;
  Label1.Font.Name:=FontDialog1.Font.Name;
  Label1.Font.Size:=FontDialog1.Font.Size+1;
  Label2.Font.Name:=FontDialog1.Font.Name;
  Label2.Font.Size:=FontDialog1.Font.Size+1;
  LSize.Font.Name:=FontDialog1.Font.Name;
  LSize.Font.Size:=FontDialog1.Font.Size+1;
  LType.Font.Name:=FontDialog1.Font.Name;
  LType.Font.Size:=FontDialog1.Font.Size+1;
  Button1.Font.Name:=FontDialog1.Font.Name;
  Button1.Font.Size:=FontDialog1.Font.Size;
  Button2.Font.Name:=FontDialog1.Font.Name;
  Button2.Font.Size:=FontDialog1.Font.Size;
  Button3.Font.Name:=FontDialog1.Font.Name;
  Button3.Font.Size:=FontDialog1.Font.Size;
  Button4.Font.Name:=FontDialog1.Font.Name;
  Button4.Font.Size:=FontDialog1.Font.Size;
  Button5.Font.Name:=FontDialog1.Font.Name;
  Button5.Font.Size:=FontDialog1.Font.Size;
  Button6.Font.Name:=FontDialog1.Font.Name;
  Button6.Font.Size:=FontDialog1.Font.Size;
  Button7.Font.Name:=FontDialog1.Font.Name;
  Button7.Font.Size:=FontDialog1.Font.Size;
  Button8.Font.Name:=FontDialog1.Font.Name;
  Button8.Font.Size:=FontDialog1.Font.Size;
  Button9.Font.Name:=FontDialog1.Font.Name;
  Button9.Font.Size:=FontDialog1.Font.Size;
  Button10.Font.Name:=FontDialog1.Font.Name;
  Button10.Font.Size:=FontDialog1.Font.Size;
  Status.Font.Name:=FontDialog1.Font.Name;
  Status.Font.Size:=FontDialog1.Font.Size;
  AssignFile(f, '.nlcl-fonts');
  Rewrite(f);
  WriteLn(f, FontDialog1.Font.Name);
  WriteLn(f, IntToStr(FontDialog1.Font.Size));
  CloseFile(f);
 end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 ShowMessage('Sorry, but this function is not yet implemented! Please wait for the next release :-)');
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
 ShowMessage('Sorry, but this function is not yet implemented! Please wait for the next release :-)');
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
 ShowMessage('Sorry, but this function is not yet implemented! Please wait for the next release :-)');
end;

end.

